using System;

namespace Adaptation.FileHandlers.MoveAllFiles.ApiController;

public readonly struct KeyPressEvent
{
    public DateTime DateTime { get; }
    public EventCode EventCode { get; }
    public KeyState KeyState { get; }
    public TimeSpan TimeSpan { get; }

    public KeyPressEvent(DateTime dateTime, EventCode eventCode, KeyState keyState, TimeSpan timeSpan)
    {
        DateTime = dateTime;
        EventCode = eventCode;
        KeyState = keyState;
        TimeSpan = timeSpan;
    }

}