namespace Adaptation.FileHandlers.TIBCO.Transport;

public class Input
{

    public string Area { get; }
    public string EquipmentType { get; }
    public string MID { get; }
    public string Slot { get; }
    public string MesEntity { get; }
    public string Recipe { get; }
    public string Sequence { get; }

    [System.Text.Json.Serialization.JsonConstructor]
    public Input(string area,
                 string equipmentType,
                 string mid,
                 string slot,
                 string mesEntity,
                 string recipe,
                 string sequence)
    {

        Area = area;
        EquipmentType = equipmentType;
        MID = mid;
        Slot = slot;
        MesEntity = mesEntity;
        Recipe = recipe;
        Sequence = sequence;
    }

    internal Input(Input input, string mid)
    {
        Area = input.Area;
        EquipmentType = input.EquipmentType;
        MID = mid;
        Slot = input.Slot;
        MesEntity = input.MesEntity;
        Recipe = input.Recipe;
        Sequence = input.Sequence;
    }

}