using System.Text.Json.Serialization;

namespace Adaptation.FileHandlers.TIBCO.Transport;

public class Run
{

    [JsonPropertyName("rds_no")]
    public int RdsNo { get; set; }

    [JsonPropertyName("max_rds_layer_keys_mv_no")]
    public int MaxRdsLayerKeysMvNo { get; set; }

    [JsonPropertyName("max_part_no")]
    public string MaxPartNo { get; set; }

    [JsonPropertyName("max_part_no_substr_0")]
    public string MaxPartNoSubstr0 { get; set; }

    [JsonPropertyName("max_part_no_substr_1")]
    public string MaxPartNoSubstr1 { get; set; }

    [JsonPropertyName("part_no")]
    public string PartNo { get; set; }

    [JsonPropertyName("reactor")]
    public int Reactor { get; set; }

    [JsonPropertyName("ps_no")]
    public string PSN { get; set; }

    [JsonPropertyName("load_lock_side")]
    public string LoadLockSide { get; set; }

    [JsonPropertyName("reactor_type")]
    public string ReactorType { get; set; }

    [JsonPropertyName("recipe_name")]
    public string RecipeName { get; set; }

    [JsonPropertyName("recipe_no")]
    public int RecipeNo { get; set; }

    [JsonPropertyName("spec_type")]
    public string SpecType { get; set; }

    [JsonPropertyName("react_tool_id")]
    public string ReactToolId { get; set; }

    [JsonPropertyName("epi_layer")]
    public string EpiLayer { get; set; }

    [JsonPropertyName("epi_step")]
    public int? EpiStep { get; set; }

    [JsonPropertyName("epi_step_lsid")]
    public string EpiStepLsid { get; set; }

    [JsonPropertyName("epi_dopant")]
    public string EpiDopant { get; set; }

    [JsonPropertyName("epi_thick_min")]
    public double? EpiThickMin { get; set; }

    [JsonPropertyName("epi_thick_max")]
    public double? EpiThickMax { get; set; }

    [JsonPropertyName("epi_thick_targ")]
    public double? EpiThickTarg { get; set; }

    [JsonPropertyName("epi_res_min")]
    public double? EpiResMin { get; set; }

    [JsonPropertyName("epi_res_max")]
    public double? EpiResMax { get; set; }

    [JsonPropertyName("epi_res_targ")]
    public double? EpiResTarg { get; set; }

    [JsonPropertyName("zone")]
    public string Zone { get; set; }

}