using Adaptation.Shared;
using Adaptation.Shared.Methods;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.Json;

namespace Adaptation.FileHandlers.txt;

public class Description : IDescription, Shared.Properties.IDescription
{

    public int Test { get; set; }
    public int Count { get; set; }
    public int Index { get; set; }
    //
    public string EventName { get; set; }
    public string NullData { get; set; }
    public string JobID { get; set; }
    public string Sequence { get; set; }
    public string MesEntity { get; set; }
    public string ReportFullPath { get; set; }
    public string ProcessJobID { get; set; }
    public string MID { get; set; }
    //
    public string Date { get; set; }
    public string Employee { get; set; }
    public string Lot { get; set; }
    public string PSN { get; set; }
    public string Reactor { get; set; }
    public string Recipe { get; set; }
    //
    public string Grade { get; set; }
    public string HeaderUniqueId { get; set; }
    public string RDS { get; set; }
    public string Session { get; set; }
    public string Side { get; set; }
    public string SrcDest { get; set; }
    public string UniqueId { get; set; }
    public string WaferID { get; set; }
    //
    public string DcnAllMax { get; set; }
    public string DcnAllMean { get; set; }
    public string DcnAllMin { get; set; }
    public string DcnAllStdDev { get; set; }
    public string DcnAreaCountMax { get; set; }
    public string DcnAreaCountMean { get; set; }
    public string DcnAreaCountMin { get; set; }
    public string DcnAreaCountStdDev { get; set; }
    public string DcnAreaMax { get; set; }
    public string DcnAreaMean { get; set; }
    public string DcnAreaMin { get; set; }
    public string DcnAreaStdDev { get; set; }
    public string DcnBin1Max { get; set; }
    public string DcnBin1Mean { get; set; }
    public string DcnBin1Min { get; set; }
    public string DcnBin1StdDev { get; set; }
    public string DcnBin2Max { get; set; }
    public string DcnBin2Mean { get; set; }
    public string DcnBin2Min { get; set; }
    public string DcnBin2StdDev { get; set; }
    public string DcnBin3Max { get; set; }
    public string DcnBin3Mean { get; set; }
    public string DcnBin3Min { get; set; }
    public string DcnBin3StdDev { get; set; }
    public string DcnBin4Max { get; set; }
    public string DcnBin4Mean { get; set; }
    public string DcnBin4Min { get; set; }
    public string DcnBin4StdDev { get; set; }
    public string DcnBin5Max { get; set; }
    public string DcnBin5Mean { get; set; }
    public string DcnBin5Min { get; set; }
    public string DcnBin5StdDev { get; set; }
    public string DcnBin6Max { get; set; }
    public string DcnBin6Mean { get; set; }
    public string DcnBin6Min { get; set; }
    public string DcnBin6StdDev { get; set; }
    public string DcnBin7Max { get; set; }
    public string DcnBin7Mean { get; set; }
    public string DcnBin7Min { get; set; }
    public string DcnBin7StdDev { get; set; }
    public string DcnBin8Max { get; set; }
    public string DcnBin8Mean { get; set; }
    public string DcnBin8Min { get; set; }
    public string DcnBin8StdDev { get; set; }
    public string DcnHazeAvgMax { get; set; }
    public string DcnHazeAvgMean { get; set; }
    public string DcnHazeAvgMin { get; set; }
    public string DcnHazeAvgStdDev { get; set; }
    public string DcnHazeMedianMax { get; set; }
    public string DcnHazeMedianMean { get; set; }
    public string DcnHazeMedianMin { get; set; }
    public string DcnHazeMedianStdDev { get; set; }
    public string DcnHazeStdDevMax { get; set; }
    public string DcnHazeStdDevMean { get; set; }
    public string DcnHazeStdDevMin { get; set; }
    public string DcnHazeStdDevStdDev { get; set; }
    public string DcnLpdESMax { get; set; }
    public string DcnLpdESMean { get; set; }
    public string DcnLpdESMin { get; set; }
    public string DcnLpdESStdDev { get; set; }
    public string DcnLpdMax { get; set; }
    public string DcnLpdMean { get; set; }
    public string DcnLpdMin { get; set; }
    public string DcnLpdNMax { get; set; }
    public string DcnLpdNMean { get; set; }
    public string DcnLpdNMin { get; set; }
    public string DcnLpdNStdDev { get; set; }
    public string DcnLpdStdDev { get; set; }
    public string DcnMicroScrMax { get; set; }
    public string DcnMicroScrMean { get; set; }
    public string DcnMicroScrMin { get; set; }
    public string DcnMicroScrStdDev { get; set; }
    public string DcnScrMax { get; set; }
    public string DcnScrMean { get; set; }
    public string DcnScrMin { get; set; }
    public string DcnScrStdDev { get; set; }
    public string DcnSlipMax { get; set; }
    public string DcnSlipMean { get; set; }
    public string DcnSlipMin { get; set; }
    public string DcnSlipStdDev { get; set; }
    public string DnnAllMax { get; set; }
    public string DnnAllMean { get; set; }
    public string DnnAllMin { get; set; }
    public string DnnAllStdDev { get; set; }
    public string DnnAreaCountMax { get; set; }
    public string DnnAreaCountMean { get; set; }
    public string DnnAreaCountMin { get; set; }
    public string DnnAreaCountStdDev { get; set; }
    public string DnnAreaMax { get; set; }
    public string DnnAreaMean { get; set; }
    public string DnnAreaMin { get; set; }
    public string DnnAreaStdDev { get; set; }
    public string DnnBin1Max { get; set; }
    public string DnnBin1Mean { get; set; }
    public string DnnBin1Min { get; set; }
    public string DnnBin1StdDev { get; set; }
    public string DnnBin2Max { get; set; }
    public string DnnBin2Mean { get; set; }
    public string DnnBin2Min { get; set; }
    public string DnnBin2StdDev { get; set; }
    public string DnnBin3Max { get; set; }
    public string DnnBin3Mean { get; set; }
    public string DnnBin3Min { get; set; }
    public string DnnBin3StdDev { get; set; }
    public string DnnBin4Max { get; set; }
    public string DnnBin4Mean { get; set; }
    public string DnnBin4Min { get; set; }
    public string DnnBin4StdDev { get; set; }
    public string DnnBin5Max { get; set; }
    public string DnnBin5Mean { get; set; }
    public string DnnBin5Min { get; set; }
    public string DnnBin5StdDev { get; set; }
    public string DnnBin6Max { get; set; }
    public string DnnBin6Mean { get; set; }
    public string DnnBin6Min { get; set; }
    public string DnnBin6StdDev { get; set; }
    public string DnnBin7Max { get; set; }
    public string DnnBin7Mean { get; set; }
    public string DnnBin7Min { get; set; }
    public string DnnBin7StdDev { get; set; }
    public string DnnBin8Max { get; set; }
    public string DnnBin8Mean { get; set; }
    public string DnnBin8Min { get; set; }
    public string DnnBin8StdDev { get; set; }
    public string DnnHazeAvgMax { get; set; }
    public string DnnHazeAvgMean { get; set; }
    public string DnnHazeAvgMin { get; set; }
    public string DnnHazeAvgStdDev { get; set; }
    public string DnnHazeMedianMax { get; set; }
    public string DnnHazeMedianMean { get; set; }
    public string DnnHazeMedianMin { get; set; }
    public string DnnHazeMedianStdDev { get; set; }
    public string DnnHazeStdDevMax { get; set; }
    public string DnnHazeStdDevMean { get; set; }
    public string DnnHazeStdDevMin { get; set; }
    public string DnnHazeStdDevStdDev { get; set; }
    public string DnnLpdESMax { get; set; }
    public string DnnLpdESMean { get; set; }
    public string DnnLpdESMin { get; set; }
    public string DnnLpdESStdDev { get; set; }
    public string DnnLpdMax { get; set; }
    public string DnnLpdMean { get; set; }
    public string DnnLpdMin { get; set; }
    public string DnnLpdNMax { get; set; }
    public string DnnLpdNMean { get; set; }
    public string DnnLpdNMin { get; set; }
    public string DnnLpdNStdDev { get; set; }
    public string DnnLpdStdDev { get; set; }
    public string DnnMicroScrMax { get; set; }
    public string DnnMicroScrMean { get; set; }
    public string DnnMicroScrMin { get; set; }
    public string DnnMicroScrStdDev { get; set; }
    public string DnnScrMax { get; set; }
    public string DnnScrMean { get; set; }
    public string DnnScrMin { get; set; }
    public string DnnScrStdDev { get; set; }
    public string DnnSlipMax { get; set; }
    public string DnnSlipMean { get; set; }
    public string DnnSlipMin { get; set; }
    public string DnnSlipStdDev { get; set; }
    public string DwnAllMax { get; set; }
    public string DwnAllMean { get; set; }
    public string DwnAllMin { get; set; }
    public string DwnAllStdDev { get; set; }
    public string DwnAreaCountMax { get; set; }
    public string DwnAreaCountMean { get; set; }
    public string DwnAreaCountMin { get; set; }
    public string DwnAreaCountStdDev { get; set; }
    public string DwnAreaMax { get; set; }
    public string DwnAreaMean { get; set; }
    public string DwnAreaMin { get; set; }
    public string DwnAreaStdDev { get; set; }
    public string DwnBin1Max { get; set; }
    public string DwnBin1Mean { get; set; }
    public string DwnBin1Min { get; set; }
    public string DwnBin1StdDev { get; set; }
    public string DwnBin2Max { get; set; }
    public string DwnBin2Mean { get; set; }
    public string DwnBin2Min { get; set; }
    public string DwnBin2StdDev { get; set; }
    public string DwnBin3Max { get; set; }
    public string DwnBin3Mean { get; set; }
    public string DwnBin3Min { get; set; }
    public string DwnBin3StdDev { get; set; }
    public string DwnBin4Max { get; set; }
    public string DwnBin4Mean { get; set; }
    public string DwnBin4Min { get; set; }
    public string DwnBin4StdDev { get; set; }
    public string DwnBin5Max { get; set; }
    public string DwnBin5Mean { get; set; }
    public string DwnBin5Min { get; set; }
    public string DwnBin5StdDev { get; set; }
    public string DwnBin6Max { get; set; }
    public string DwnBin6Mean { get; set; }
    public string DwnBin6Min { get; set; }
    public string DwnBin6StdDev { get; set; }
    public string DwnBin7Max { get; set; }
    public string DwnBin7Mean { get; set; }
    public string DwnBin7Min { get; set; }
    public string DwnBin7StdDev { get; set; }
    public string DwnBin8Max { get; set; }
    public string DwnBin8Mean { get; set; }
    public string DwnBin8Min { get; set; }
    public string DwnBin8StdDev { get; set; }
    public string DwnHazeAvgMax { get; set; }
    public string DwnHazeAvgMean { get; set; }
    public string DwnHazeAvgMin { get; set; }
    public string DwnHazeAvgStdDev { get; set; }
    public string DwnHazeMedianMax { get; set; }
    public string DwnHazeMedianMean { get; set; }
    public string DwnHazeMedianMin { get; set; }
    public string DwnHazeMedianStdDev { get; set; }
    public string DwnHazeStdDevMax { get; set; }
    public string DwnHazeStdDevMean { get; set; }
    public string DwnHazeStdDevMin { get; set; }
    public string DwnHazeStdDevStdDev { get; set; }
    public string DwnLpdESMax { get; set; }
    public string DwnLpdESMean { get; set; }
    public string DwnLpdESMin { get; set; }
    public string DwnLpdESStdDev { get; set; }
    public string DwnLpdMax { get; set; }
    public string DwnLpdMean { get; set; }
    public string DwnLpdMin { get; set; }
    public string DwnLpdNMax { get; set; }
    public string DwnLpdNMean { get; set; }
    public string DwnLpdNMin { get; set; }
    public string DwnLpdNStdDev { get; set; }
    public string DwnLpdStdDev { get; set; }
    public string DwnMicroScrMax { get; set; }
    public string DwnMicroScrMean { get; set; }
    public string DwnMicroScrMin { get; set; }
    public string DwnMicroScrStdDev { get; set; }
    public string DwnScrMax { get; set; }
    public string DwnScrMean { get; set; }
    public string DwnScrMin { get; set; }
    public string DwnScrStdDev { get; set; }
    public string DwnSlipMax { get; set; }
    public string DwnSlipMean { get; set; }
    public string DwnSlipMin { get; set; }
    public string DwnSlipStdDev { get; set; }
    public string DcnAll { get; set; }
    public string DcnArea { get; set; }
    public string DcnAreaCount { get; set; }
    public string DcnBin1 { get; set; }
    public string DcnBin2 { get; set; }
    public string DcnBin3 { get; set; }
    public string DcnBin4 { get; set; }
    public string DcnBin5 { get; set; }
    public string DcnBin6 { get; set; }
    public string DcnBin7 { get; set; }
    public string DcnBin8 { get; set; }
    public string DcnHazeAvg { get; set; }
    public string DcnHazeMedian { get; set; }
    public string DcnHazeStdDev { get; set; }
    public string DcnLpd { get; set; }
    public string DcnLpdES { get; set; }
    public string DcnLpdN { get; set; }
    public string DcnMicroScr { get; set; }
    public string DcnScr { get; set; }
    public string DcnSlip { get; set; }
    public string DnnAll { get; set; }
    public string DnnArea { get; set; }
    public string DnnAreaCount { get; set; }
    public string DnnBin1 { get; set; }
    public string DnnBin2 { get; set; }
    public string DnnBin3 { get; set; }
    public string DnnBin4 { get; set; }
    public string DnnBin5 { get; set; }
    public string DnnBin6 { get; set; }
    public string DnnBin7 { get; set; }
    public string DnnBin8 { get; set; }
    public string DnnHazeAvg { get; set; }
    public string DnnHazeMedian { get; set; }
    public string DnnHazeStdDev { get; set; }
    public string DnnLpd { get; set; }
    public string DnnLpdES { get; set; }
    public string DnnLpdN { get; set; }
    public string DnnMicroScr { get; set; }
    public string DnnScr { get; set; }
    public string DnnSlip { get; set; }
    public string DwnAll { get; set; }
    public string DwnArea { get; set; }
    public string DwnAreaCount { get; set; }
    public string DwnBin1 { get; set; }
    public string DwnBin2 { get; set; }
    public string DwnBin3 { get; set; }
    public string DwnBin4 { get; set; }
    public string DwnBin5 { get; set; }
    public string DwnBin6 { get; set; }
    public string DwnBin7 { get; set; }
    public string DwnBin8 { get; set; }
    public string DwnHazeAvg { get; set; }
    public string DwnHazeMedian { get; set; }
    public string DwnHazeStdDev { get; set; }
    public string DwnLpd { get; set; }
    public string DwnLpdES { get; set; }
    public string DwnLpdN { get; set; }
    public string DwnMicroScr { get; set; }
    public string DwnScr { get; set; }
    public string DwnSlip { get; set; }

    string IDescription.GetEventDescription() => "File Has been read and parsed";

    List<string> IDescription.GetNames(IFileRead fileRead, Logistics logistics)
    {
        List<string> results = new();
        IDescription description = GetDefault(fileRead, logistics);
        string json = JsonSerializer.Serialize(description, description.GetType());
        object @object = JsonSerializer.Deserialize<object>(json);
        if (@object is not JsonElement jsonElement)
            throw new Exception();
        foreach (JsonProperty jsonProperty in jsonElement.EnumerateObject())
            results.Add(jsonProperty.Name);
        return results;
    }

    List<string> IDescription.GetDetailNames()
    {
        List<string> results = new()
        {
            nameof(Grade),
            nameof(HeaderUniqueId),
            nameof(RDS),
            nameof(Session),
            nameof(Side),
            nameof(SrcDest),
            nameof(UniqueId),
            nameof(WaferID)
        };
        return results;
    }

    List<string> IDescription.GetHeaderNames()
    {
        List<string> results = new()
        {
            nameof(Date),
            nameof(Employee),
            nameof(Lot),
            nameof(PSN),
            nameof(Reactor),
            nameof(Recipe)
        };
        return results;
    }

    IDescription IDescription.GetDisplayNames()
    {
        Description result = GetDisplayNames();
        return result;
    }

    List<string> IDescription.GetParameterNames()
    {
        List<string> results = new()
        {
            nameof(DcnAllMax),
            nameof(DcnAllMean),
            nameof(DcnAllMin),
            nameof(DcnAllStdDev),
            nameof(DcnAreaCountMax),
            nameof(DcnAreaCountMean),
            nameof(DcnAreaCountMin),
            nameof(DcnAreaCountStdDev),
            nameof(DcnAreaMax),
            nameof(DcnAreaMean),
            nameof(DcnAreaMin),
            nameof(DcnAreaStdDev),
            nameof(DcnBin1Max),
            nameof(DcnBin1Mean),
            nameof(DcnBin1Min),
            nameof(DcnBin1StdDev),
            nameof(DcnBin2Max),
            nameof(DcnBin2Mean),
            nameof(DcnBin2Min),
            nameof(DcnBin2StdDev),
            nameof(DcnBin3Max),
            nameof(DcnBin3Mean),
            nameof(DcnBin3Min),
            nameof(DcnBin3StdDev),
            nameof(DcnBin4Max),
            nameof(DcnBin4Mean),
            nameof(DcnBin4Min),
            nameof(DcnBin4StdDev),
            nameof(DcnBin5Max),
            nameof(DcnBin5Mean),
            nameof(DcnBin5Min),
            nameof(DcnBin5StdDev),
            nameof(DcnBin6Max),
            nameof(DcnBin6Mean),
            nameof(DcnBin6Min),
            nameof(DcnBin6StdDev),
            nameof(DcnBin7Max),
            nameof(DcnBin7Mean),
            nameof(DcnBin7Min),
            nameof(DcnBin7StdDev),
            nameof(DcnBin8Max),
            nameof(DcnBin8Mean),
            nameof(DcnBin8Min),
            nameof(DcnBin8StdDev),
            nameof(DcnHazeAvgMax),
            nameof(DcnHazeAvgMean),
            nameof(DcnHazeAvgMin),
            nameof(DcnHazeAvgStdDev),
            nameof(DcnHazeMedianMax),
            nameof(DcnHazeMedianMean),
            nameof(DcnHazeMedianMin),
            nameof(DcnHazeMedianStdDev),
            nameof(DcnHazeStdDevMax),
            nameof(DcnHazeStdDevMean),
            nameof(DcnHazeStdDevMin),
            nameof(DcnHazeStdDevStdDev),
            nameof(DcnLpdESMax),
            nameof(DcnLpdESMean),
            nameof(DcnLpdESMin),
            nameof(DcnLpdESStdDev),
            nameof(DcnLpdMax),
            nameof(DcnLpdMean),
            nameof(DcnLpdMin),
            nameof(DcnLpdNMax),
            nameof(DcnLpdNMean),
            nameof(DcnLpdNMin),
            nameof(DcnLpdNStdDev),
            nameof(DcnLpdStdDev),
            nameof(DcnMicroScrMax),
            nameof(DcnMicroScrMean),
            nameof(DcnMicroScrMin),
            nameof(DcnMicroScrStdDev),
            nameof(DcnScrMax),
            nameof(DcnScrMean),
            nameof(DcnScrMin),
            nameof(DcnScrStdDev),
            nameof(DcnSlipMax),
            nameof(DcnSlipMean),
            nameof(DcnSlipMin),
            nameof(DcnSlipStdDev),
            nameof(DnnAllMax),
            nameof(DnnAllMean),
            nameof(DnnAllMin),
            nameof(DnnAllStdDev),
            nameof(DnnAreaCountMax),
            nameof(DnnAreaCountMean),
            nameof(DnnAreaCountMin),
            nameof(DnnAreaCountStdDev),
            nameof(DnnAreaMax),
            nameof(DnnAreaMean),
            nameof(DnnAreaMin),
            nameof(DnnAreaStdDev),
            nameof(DnnBin1Max),
            nameof(DnnBin1Mean),
            nameof(DnnBin1Min),
            nameof(DnnBin1StdDev),
            nameof(DnnBin2Max),
            nameof(DnnBin2Mean),
            nameof(DnnBin2Min),
            nameof(DnnBin2StdDev),
            nameof(DnnBin3Max),
            nameof(DnnBin3Mean),
            nameof(DnnBin3Min),
            nameof(DnnBin3StdDev),
            nameof(DnnBin4Max),
            nameof(DnnBin4Mean),
            nameof(DnnBin4Min),
            nameof(DnnBin4StdDev),
            nameof(DnnBin5Max),
            nameof(DnnBin5Mean),
            nameof(DnnBin5Min),
            nameof(DnnBin5StdDev),
            nameof(DnnBin6Max),
            nameof(DnnBin6Mean),
            nameof(DnnBin6Min),
            nameof(DnnBin6StdDev),
            nameof(DnnBin7Max),
            nameof(DnnBin7Mean),
            nameof(DnnBin7Min),
            nameof(DnnBin7StdDev),
            nameof(DnnBin8Max),
            nameof(DnnBin8Mean),
            nameof(DnnBin8Min),
            nameof(DnnBin8StdDev),
            nameof(DnnHazeAvgMax),
            nameof(DnnHazeAvgMean),
            nameof(DnnHazeAvgMin),
            nameof(DnnHazeAvgStdDev),
            nameof(DnnHazeMedianMax),
            nameof(DnnHazeMedianMean),
            nameof(DnnHazeMedianMin),
            nameof(DnnHazeMedianStdDev),
            nameof(DnnHazeStdDevMax),
            nameof(DnnHazeStdDevMean),
            nameof(DnnHazeStdDevMin),
            nameof(DnnHazeStdDevStdDev),
            nameof(DnnLpdESMax),
            nameof(DnnLpdESMean),
            nameof(DnnLpdESMin),
            nameof(DnnLpdESStdDev),
            nameof(DnnLpdMax),
            nameof(DnnLpdMean),
            nameof(DnnLpdMin),
            nameof(DnnLpdNMax),
            nameof(DnnLpdNMean),
            nameof(DnnLpdNMin),
            nameof(DnnLpdNStdDev),
            nameof(DnnLpdStdDev),
            nameof(DnnMicroScrMax),
            nameof(DnnMicroScrMean),
            nameof(DnnMicroScrMin),
            nameof(DnnMicroScrStdDev),
            nameof(DnnScrMax),
            nameof(DnnScrMean),
            nameof(DnnScrMin),
            nameof(DnnScrStdDev),
            nameof(DnnSlipMax),
            nameof(DnnSlipMean),
            nameof(DnnSlipMin),
            nameof(DnnSlipStdDev),
            nameof(DwnAllMax),
            nameof(DwnAllMean),
            nameof(DwnAllMin),
            nameof(DwnAllStdDev),
            nameof(DwnAreaCountMax),
            nameof(DwnAreaCountMean),
            nameof(DwnAreaCountMin),
            nameof(DwnAreaCountStdDev),
            nameof(DwnAreaMax),
            nameof(DwnAreaMean),
            nameof(DwnAreaMin),
            nameof(DwnAreaStdDev),
            nameof(DwnBin1Max),
            nameof(DwnBin1Mean),
            nameof(DwnBin1Min),
            nameof(DwnBin1StdDev),
            nameof(DwnBin2Max),
            nameof(DwnBin2Mean),
            nameof(DwnBin2Min),
            nameof(DwnBin2StdDev),
            nameof(DwnBin3Max),
            nameof(DwnBin3Mean),
            nameof(DwnBin3Min),
            nameof(DwnBin3StdDev),
            nameof(DwnBin4Max),
            nameof(DwnBin4Mean),
            nameof(DwnBin4Min),
            nameof(DwnBin4StdDev),
            nameof(DwnBin5Max),
            nameof(DwnBin5Mean),
            nameof(DwnBin5Min),
            nameof(DwnBin5StdDev),
            nameof(DwnBin6Max),
            nameof(DwnBin6Mean),
            nameof(DwnBin6Min),
            nameof(DwnBin6StdDev),
            nameof(DwnBin7Max),
            nameof(DwnBin7Mean),
            nameof(DwnBin7Min),
            nameof(DwnBin7StdDev),
            nameof(DwnBin8Max),
            nameof(DwnBin8Mean),
            nameof(DwnBin8Min),
            nameof(DwnBin8StdDev),
            nameof(DwnHazeAvgMax),
            nameof(DwnHazeAvgMean),
            nameof(DwnHazeAvgMin),
            nameof(DwnHazeAvgStdDev),
            nameof(DwnHazeMedianMax),
            nameof(DwnHazeMedianMean),
            nameof(DwnHazeMedianMin),
            nameof(DwnHazeMedianStdDev),
            nameof(DwnHazeStdDevMax),
            nameof(DwnHazeStdDevMean),
            nameof(DwnHazeStdDevMin),
            nameof(DwnHazeStdDevStdDev),
            nameof(DwnLpdESMax),
            nameof(DwnLpdESMean),
            nameof(DwnLpdESMin),
            nameof(DwnLpdESStdDev),
            nameof(DwnLpdMax),
            nameof(DwnLpdMean),
            nameof(DwnLpdMin),
            nameof(DwnLpdNMax),
            nameof(DwnLpdNMean),
            nameof(DwnLpdNMin),
            nameof(DwnLpdNStdDev),
            nameof(DwnLpdStdDev),
            nameof(DwnMicroScrMax),
            nameof(DwnMicroScrMean),
            nameof(DwnMicroScrMin),
            nameof(DwnMicroScrStdDev),
            nameof(DwnScrMax),
            nameof(DwnScrMean),
            nameof(DwnScrMin),
            nameof(DwnScrStdDev),
            nameof(DwnSlipMax),
            nameof(DwnSlipMean),
            nameof(DwnSlipMin),
            nameof(DwnSlipStdDev),
            nameof(DcnAll),
            nameof(DcnArea),
            nameof(DcnAreaCount),
            nameof(DcnBin1),
            nameof(DcnBin2),
            nameof(DcnBin3),
            nameof(DcnBin4),
            nameof(DcnBin5),
            nameof(DcnBin6),
            nameof(DcnBin7),
            nameof(DcnBin8),
            nameof(DcnHazeAvg),
            nameof(DcnHazeMedian),
            nameof(DcnHazeStdDev),
            nameof(DcnLpd),
            nameof(DcnLpdES),
            nameof(DcnLpdN),
            nameof(DcnMicroScr),
            nameof(DcnScr),
            nameof(DcnSlip),
            nameof(DnnAll),
            nameof(DnnArea),
            nameof(DnnAreaCount),
            nameof(DnnBin1),
            nameof(DnnBin2),
            nameof(DnnBin3),
            nameof(DnnBin4),
            nameof(DnnBin5),
            nameof(DnnBin6),
            nameof(DnnBin7),
            nameof(DnnBin8),
            nameof(DnnHazeAvg),
            nameof(DnnHazeMedian),
            nameof(DnnHazeStdDev),
            nameof(DnnLpd),
            nameof(DnnLpdES),
            nameof(DnnLpdN),
            nameof(DnnMicroScr),
            nameof(DnnScr),
            nameof(DnnSlip),
            nameof(DwnAll),
            nameof(DwnArea),
            nameof(DwnAreaCount),
            nameof(DwnBin1),
            nameof(DwnBin2),
            nameof(DwnBin3),
            nameof(DwnBin4),
            nameof(DwnBin5),
            nameof(DwnBin6),
            nameof(DwnBin7),
            nameof(DwnBin8),
            nameof(DwnHazeAvg),
            nameof(DwnHazeMedian),
            nameof(DwnHazeStdDev),
            nameof(DwnLpd),
            nameof(DwnLpdES),
            nameof(DwnLpdN),
            nameof(DwnMicroScr),
            nameof(DwnScr),
            nameof(DwnSlip)
        };
        return results;
    }

    JsonProperty[] IDescription.GetDefault(IFileRead fileRead, Logistics logistics)
    {
        JsonProperty[] results;
        IDescription description = GetDefault(fileRead, logistics);
        string json = JsonSerializer.Serialize(description, description.GetType());
        object @object = JsonSerializer.Deserialize<object>(json);
        results = ((JsonElement)@object).EnumerateObject().ToArray();
        return results;
    }

    List<string> IDescription.GetPairedParameterNames()
    {
        List<string> results = new();
        return results;
    }

    List<string> IDescription.GetIgnoreParameterNames(Test test)
    {
        List<string> results = new();
        return results;
    }

    IDescription IDescription.GetDefaultDescription(IFileRead fileRead, Logistics logistics)
    {
        Description result = GetDefault(fileRead, logistics);
        return result;
    }

    Dictionary<string, string> IDescription.GetDisplayNamesJsonElement(IFileRead fileRead)
    {
        Dictionary<string, string> results = new();
        IDescription description = GetDisplayNames();
        string json = JsonSerializer.Serialize(description, description.GetType());
        JsonElement jsonElement = JsonSerializer.Deserialize<JsonElement>(json);
        foreach (JsonProperty jsonProperty in jsonElement.EnumerateObject())
        {
            if (!results.ContainsKey(jsonProperty.Name))
                results.Add(jsonProperty.Name, string.Empty);
            if (jsonProperty.Value is JsonElement jsonPropertyValue)
                results[jsonProperty.Name] = jsonPropertyValue.ToString();
        }
        return results;
    }

    List<IDescription> IDescription.GetDescriptions(IFileRead fileRead, Logistics logistics, List<Test> tests, IProcessData iProcessData)
    {
        List<IDescription> results = new();
        if (iProcessData is null || !iProcessData.Details.Any() || iProcessData is not ProcessData processData)
            results.Add(GetDefault(fileRead, logistics));
        else
        {
            string nullData;
            Description description;
            object configDataNullData = fileRead.NullData;
            if (configDataNullData is null)
                nullData = string.Empty;
            else
                nullData = configDataNullData.ToString();
            for (int i = 0; i < iProcessData.Details.Count; i++)
            {
                if (iProcessData.Details[i] is not Detail detail)
                    continue;
                description = new Description
                {
                    Test = (int)tests[i],
                    Count = tests.Count,
                    Index = i,
                    //
                    EventName = fileRead.EventName,
                    NullData = nullData,
                    JobID = fileRead.CellInstanceName,
                    Sequence = logistics.Sequence.ToString(),
                    MesEntity = logistics.MesEntity,
                    ReportFullPath = logistics.ReportFullPath,
                    ProcessJobID = logistics.ProcessJobID,
                    MID = logistics.MID,
                    //
                    Date = processData.Date.ToString(GetDateFormat()),
                    Employee = processData.Employee,
                    Lot = processData.Lot,
                    PSN = processData.PSN,
                    Reactor = processData.Reactor,
                    Recipe = processData.Recipe,
                    //
                    Grade = detail.Grade,
                    HeaderUniqueId = detail.HeaderUniqueID,
                    RDS = processData.RDS,
                    Session = processData.Session,
                    Side = detail.Side,
                    SrcDest = detail.SrcDest,
                    UniqueId = detail.UniqueID,
                    WaferID = detail.WaferID,
                    //
                    DcnAllMax = processData.DcnAllMax,
                    DcnAllMean = processData.DcnAllMean,
                    DcnAllMin = processData.DcnAllMin,
                    DcnAllStdDev = processData.DcnAllStdDev,
                    DcnAreaCountMax = processData.DcnAreaCountMax,
                    DcnAreaCountMean = processData.DcnAreaCountMean,
                    DcnAreaCountMin = processData.DcnAreaCountMin,
                    DcnAreaCountStdDev = processData.DcnAreaCountStdDev,
                    DcnAreaMax = processData.DcnAreaMax,
                    DcnAreaMean = processData.DcnAreaMean,
                    DcnAreaMin = processData.DcnAreaMin,
                    DcnAreaStdDev = processData.DcnAreaStdDev,
                    DcnBin1Max = processData.DcnBin1Max,
                    DcnBin1Mean = processData.DcnBin1Mean,
                    DcnBin1Min = processData.DcnBin1Min,
                    DcnBin1StdDev = processData.DcnBin1StdDev,
                    DcnBin2Max = processData.DcnBin2Max,
                    DcnBin2Mean = processData.DcnBin2Mean,
                    DcnBin2Min = processData.DcnBin2Min,
                    DcnBin2StdDev = processData.DcnBin2StdDev,
                    DcnBin3Max = processData.DcnBin3Max,
                    DcnBin3Mean = processData.DcnBin3Mean,
                    DcnBin3Min = processData.DcnBin3Min,
                    DcnBin3StdDev = processData.DcnBin3StdDev,
                    DcnBin4Max = processData.DcnBin4Max,
                    DcnBin4Mean = processData.DcnBin4Mean,
                    DcnBin4Min = processData.DcnBin4Min,
                    DcnBin4StdDev = processData.DcnBin4StdDev,
                    DcnBin5Max = processData.DcnBin5Max,
                    DcnBin5Mean = processData.DcnBin5Mean,
                    DcnBin5Min = processData.DcnBin5Min,
                    DcnBin5StdDev = processData.DcnBin5StdDev,
                    DcnBin6Max = processData.DcnBin6Max,
                    DcnBin6Mean = processData.DcnBin6Mean,
                    DcnBin6Min = processData.DcnBin6Min,
                    DcnBin6StdDev = processData.DcnBin6StdDev,
                    DcnBin7Max = processData.DcnBin7Max,
                    DcnBin7Mean = processData.DcnBin7Mean,
                    DcnBin7Min = processData.DcnBin7Min,
                    DcnBin7StdDev = processData.DcnBin7StdDev,
                    DcnBin8Max = processData.DcnBin8Max,
                    DcnBin8Mean = processData.DcnBin8Mean,
                    DcnBin8Min = processData.DcnBin8Min,
                    DcnBin8StdDev = processData.DcnBin8StdDev,
                    DcnHazeAvgMax = processData.DcnHazeAvgMax,
                    DcnHazeAvgMean = processData.DcnHazeAvgMean,
                    DcnHazeAvgMin = processData.DcnHazeAvgMin,
                    DcnHazeAvgStdDev = processData.DcnHazeAvgStdDev,
                    DcnHazeMedianMax = processData.DcnHazeMedianMax,
                    DcnHazeMedianMean = processData.DcnHazeMedianMean,
                    DcnHazeMedianMin = processData.DcnHazeMedianMin,
                    DcnHazeMedianStdDev = processData.DcnHazeMedianStdDev,
                    DcnHazeStdDevMax = processData.DcnHazeStdDevMax,
                    DcnHazeStdDevMean = processData.DcnHazeStdDevMean,
                    DcnHazeStdDevMin = processData.DcnHazeStdDevMin,
                    DcnHazeStdDevStdDev = processData.DcnHazeStdDevStdDev,
                    DcnLpdESMax = processData.DcnLpdESMax,
                    DcnLpdESMean = processData.DcnLpdESMean,
                    DcnLpdESMin = processData.DcnLpdESMin,
                    DcnLpdESStdDev = processData.DcnLpdESStdDev,
                    DcnLpdMax = processData.DcnLpdMax,
                    DcnLpdMean = processData.DcnLpdMean,
                    DcnLpdMin = processData.DcnLpdMin,
                    DcnLpdNMax = processData.DcnLpdNMax,
                    DcnLpdNMean = processData.DcnLpdNMean,
                    DcnLpdNMin = processData.DcnLpdNMin,
                    DcnLpdNStdDev = processData.DcnLpdNStdDev,
                    DcnLpdStdDev = processData.DcnLpdStdDev,
                    DcnMicroScrMax = processData.DcnMicroScrMax,
                    DcnMicroScrMean = processData.DcnMicroScrMean,
                    DcnMicroScrMin = processData.DcnMicroScrMin,
                    DcnMicroScrStdDev = processData.DcnMicroScrStdDev,
                    DcnScrMax = processData.DcnScrMax,
                    DcnScrMean = processData.DcnScrMean,
                    DcnScrMin = processData.DcnScrMin,
                    DcnScrStdDev = processData.DcnScrStdDev,
                    DcnSlipMax = processData.DcnSlipMax,
                    DcnSlipMean = processData.DcnSlipMean,
                    DcnSlipMin = processData.DcnSlipMin,
                    DcnSlipStdDev = processData.DcnSlipStdDev,
                    DnnAllMax = processData.DnnAllMax,
                    DnnAllMean = processData.DnnAllMean,
                    DnnAllMin = processData.DnnAllMin,
                    DnnAllStdDev = processData.DnnAllStdDev,
                    DnnAreaCountMax = processData.DnnAreaCountMax,
                    DnnAreaCountMean = processData.DnnAreaCountMean,
                    DnnAreaCountMin = processData.DnnAreaCountMin,
                    DnnAreaCountStdDev = processData.DnnAreaCountStdDev,
                    DnnAreaMax = processData.DnnAreaMax,
                    DnnAreaMean = processData.DnnAreaMean,
                    DnnAreaMin = processData.DnnAreaMin,
                    DnnAreaStdDev = processData.DnnAreaStdDev,
                    DnnBin1Max = processData.DnnBin1Max,
                    DnnBin1Mean = processData.DnnBin1Mean,
                    DnnBin1Min = processData.DnnBin1Min,
                    DnnBin1StdDev = processData.DnnBin1StdDev,
                    DnnBin2Max = processData.DnnBin2Max,
                    DnnBin2Mean = processData.DnnBin2Mean,
                    DnnBin2Min = processData.DnnBin2Min,
                    DnnBin2StdDev = processData.DnnBin2StdDev,
                    DnnBin3Max = processData.DnnBin3Max,
                    DnnBin3Mean = processData.DnnBin3Mean,
                    DnnBin3Min = processData.DnnBin3Min,
                    DnnBin3StdDev = processData.DnnBin3StdDev,
                    DnnBin4Max = processData.DnnBin4Max,
                    DnnBin4Mean = processData.DnnBin4Mean,
                    DnnBin4Min = processData.DnnBin4Min,
                    DnnBin4StdDev = processData.DnnBin4StdDev,
                    DnnBin5Max = processData.DnnBin5Max,
                    DnnBin5Mean = processData.DnnBin5Mean,
                    DnnBin5Min = processData.DnnBin5Min,
                    DnnBin5StdDev = processData.DnnBin5StdDev,
                    DnnBin6Max = processData.DnnBin6Max,
                    DnnBin6Mean = processData.DnnBin6Mean,
                    DnnBin6Min = processData.DnnBin6Min,
                    DnnBin6StdDev = processData.DnnBin6StdDev,
                    DnnBin7Max = processData.DnnBin7Max,
                    DnnBin7Mean = processData.DnnBin7Mean,
                    DnnBin7Min = processData.DnnBin7Min,
                    DnnBin7StdDev = processData.DnnBin7StdDev,
                    DnnBin8Max = processData.DnnBin8Max,
                    DnnBin8Mean = processData.DnnBin8Mean,
                    DnnBin8Min = processData.DnnBin8Min,
                    DnnBin8StdDev = processData.DnnBin8StdDev,
                    DnnHazeAvgMax = processData.DnnHazeAvgMax,
                    DnnHazeAvgMean = processData.DnnHazeAvgMean,
                    DnnHazeAvgMin = processData.DnnHazeAvgMin,
                    DnnHazeAvgStdDev = processData.DnnHazeAvgStdDev,
                    DnnHazeMedianMax = processData.DnnHazeMedianMax,
                    DnnHazeMedianMean = processData.DnnHazeMedianMean,
                    DnnHazeMedianMin = processData.DnnHazeMedianMin,
                    DnnHazeMedianStdDev = processData.DnnHazeMedianStdDev,
                    DnnHazeStdDevMax = processData.DnnHazeStdDevMax,
                    DnnHazeStdDevMean = processData.DnnHazeStdDevMean,
                    DnnHazeStdDevMin = processData.DnnHazeStdDevMin,
                    DnnHazeStdDevStdDev = processData.DnnHazeStdDevStdDev,
                    DnnLpdESMax = processData.DnnLpdESMax,
                    DnnLpdESMean = processData.DnnLpdESMean,
                    DnnLpdESMin = processData.DnnLpdESMin,
                    DnnLpdESStdDev = processData.DnnLpdESStdDev,
                    DnnLpdMax = processData.DnnLpdMax,
                    DnnLpdMean = processData.DnnLpdMean,
                    DnnLpdMin = processData.DnnLpdMin,
                    DnnLpdNMax = processData.DnnLpdNMax,
                    DnnLpdNMean = processData.DnnLpdNMean,
                    DnnLpdNMin = processData.DnnLpdNMin,
                    DnnLpdNStdDev = processData.DnnLpdNStdDev,
                    DnnLpdStdDev = processData.DnnLpdStdDev,
                    DnnMicroScrMax = processData.DnnMicroScrMax,
                    DnnMicroScrMean = processData.DnnMicroScrMean,
                    DnnMicroScrMin = processData.DnnMicroScrMin,
                    DnnMicroScrStdDev = processData.DnnMicroScrStdDev,
                    DnnScrMax = processData.DnnScrMax,
                    DnnScrMean = processData.DnnScrMean,
                    DnnScrMin = processData.DnnScrMin,
                    DnnScrStdDev = processData.DnnScrStdDev,
                    DnnSlipMax = processData.DnnSlipMax,
                    DnnSlipMean = processData.DnnSlipMean,
                    DnnSlipMin = processData.DnnSlipMin,
                    DnnSlipStdDev = processData.DnnSlipStdDev,
                    DwnAllMax = processData.DwnAllMax,
                    DwnAllMean = processData.DwnAllMean,
                    DwnAllMin = processData.DwnAllMin,
                    DwnAllStdDev = processData.DwnAllStdDev,
                    DwnAreaCountMax = processData.DwnAreaCountMax,
                    DwnAreaCountMean = processData.DwnAreaCountMean,
                    DwnAreaCountMin = processData.DwnAreaCountMin,
                    DwnAreaCountStdDev = processData.DwnAreaCountStdDev,
                    DwnAreaMax = processData.DwnAreaMax,
                    DwnAreaMean = processData.DwnAreaMean,
                    DwnAreaMin = processData.DwnAreaMin,
                    DwnAreaStdDev = processData.DwnAreaStdDev,
                    DwnBin1Max = processData.DwnBin1Max,
                    DwnBin1Mean = processData.DwnBin1Mean,
                    DwnBin1Min = processData.DwnBin1Min,
                    DwnBin1StdDev = processData.DwnBin1StdDev,
                    DwnBin2Max = processData.DwnBin2Max,
                    DwnBin2Mean = processData.DwnBin2Mean,
                    DwnBin2Min = processData.DwnBin2Min,
                    DwnBin2StdDev = processData.DwnBin2StdDev,
                    DwnBin3Max = processData.DwnBin3Max,
                    DwnBin3Mean = processData.DwnBin3Mean,
                    DwnBin3Min = processData.DwnBin3Min,
                    DwnBin3StdDev = processData.DwnBin3StdDev,
                    DwnBin4Max = processData.DwnBin4Max,
                    DwnBin4Mean = processData.DwnBin4Mean,
                    DwnBin4Min = processData.DwnBin4Min,
                    DwnBin4StdDev = processData.DwnBin4StdDev,
                    DwnBin5Max = processData.DwnBin5Max,
                    DwnBin5Mean = processData.DwnBin5Mean,
                    DwnBin5Min = processData.DwnBin5Min,
                    DwnBin5StdDev = processData.DwnBin5StdDev,
                    DwnBin6Max = processData.DwnBin6Max,
                    DwnBin6Mean = processData.DwnBin6Mean,
                    DwnBin6Min = processData.DwnBin6Min,
                    DwnBin6StdDev = processData.DwnBin6StdDev,
                    DwnBin7Max = processData.DwnBin7Max,
                    DwnBin7Mean = processData.DwnBin7Mean,
                    DwnBin7Min = processData.DwnBin7Min,
                    DwnBin7StdDev = processData.DwnBin7StdDev,
                    DwnBin8Max = processData.DwnBin8Max,
                    DwnBin8Mean = processData.DwnBin8Mean,
                    DwnBin8Min = processData.DwnBin8Min,
                    DwnBin8StdDev = processData.DwnBin8StdDev,
                    DwnHazeAvgMax = processData.DwnHazeAvgMax,
                    DwnHazeAvgMean = processData.DwnHazeAvgMean,
                    DwnHazeAvgMin = processData.DwnHazeAvgMin,
                    DwnHazeAvgStdDev = processData.DwnHazeAvgStdDev,
                    DwnHazeMedianMax = processData.DwnHazeMedianMax,
                    DwnHazeMedianMean = processData.DwnHazeMedianMean,
                    DwnHazeMedianMin = processData.DwnHazeMedianMin,
                    DwnHazeMedianStdDev = processData.DwnHazeMedianStdDev,
                    DwnHazeStdDevMax = processData.DwnHazeStdDevMax,
                    DwnHazeStdDevMean = processData.DwnHazeStdDevMean,
                    DwnHazeStdDevMin = processData.DwnHazeStdDevMin,
                    DwnHazeStdDevStdDev = processData.DwnHazeStdDevStdDev,
                    DwnLpdESMax = processData.DwnLpdESMax,
                    DwnLpdESMean = processData.DwnLpdESMean,
                    DwnLpdESMin = processData.DwnLpdESMin,
                    DwnLpdESStdDev = processData.DwnLpdESStdDev,
                    DwnLpdMax = processData.DwnLpdMax,
                    DwnLpdMean = processData.DwnLpdMean,
                    DwnLpdMin = processData.DwnLpdMin,
                    DwnLpdNMax = processData.DwnLpdNMax,
                    DwnLpdNMean = processData.DwnLpdNMean,
                    DwnLpdNMin = processData.DwnLpdNMin,
                    DwnLpdNStdDev = processData.DwnLpdNStdDev,
                    DwnLpdStdDev = processData.DwnLpdStdDev,
                    DwnMicroScrMax = processData.DwnMicroScrMax,
                    DwnMicroScrMean = processData.DwnMicroScrMean,
                    DwnMicroScrMin = processData.DwnMicroScrMin,
                    DwnMicroScrStdDev = processData.DwnMicroScrStdDev,
                    DwnScrMax = processData.DwnScrMax,
                    DwnScrMean = processData.DwnScrMean,
                    DwnScrMin = processData.DwnScrMin,
                    DwnScrStdDev = processData.DwnScrStdDev,
                    DwnSlipMax = processData.DwnSlipMax,
                    DwnSlipMean = processData.DwnSlipMean,
                    DwnSlipMin = processData.DwnSlipMin,
                    DwnSlipStdDev = processData.DwnSlipStdDev,
                    DcnAll = detail.DcnAll,
                    DcnArea = detail.DcnArea,
                    DcnAreaCount = detail.DcnAreaCount,
                    DcnBin1 = detail.DcnBin1,
                    DcnBin2 = detail.DcnBin2,
                    DcnBin3 = detail.DcnBin3,
                    DcnBin4 = detail.DcnBin4,
                    DcnBin5 = detail.DcnBin5,
                    DcnBin6 = detail.DcnBin6,
                    DcnBin7 = detail.DcnBin7,
                    DcnBin8 = detail.DcnBin8,
                    DcnHazeAvg = detail.DcnHazeAvg,
                    DcnHazeMedian = detail.DcnHazeMedian,
                    DcnHazeStdDev = detail.DcnHazeStdDev,
                    DcnLpd = detail.DcnLpd,
                    DcnLpdES = detail.DcnLpdES,
                    DcnLpdN = detail.DcnLpdN,
                    DcnMicroScr = detail.DcnMicroScr,
                    DcnScr = detail.DcnScr,
                    DcnSlip = detail.DcnSlip,
                    DnnAll = detail.DnnAll,
                    DnnArea = detail.DnnArea,
                    DnnAreaCount = detail.DnnAreaCount,
                    DnnBin1 = detail.DnnBin1,
                    DnnBin2 = detail.DnnBin2,
                    DnnBin3 = detail.DnnBin3,
                    DnnBin4 = detail.DnnBin4,
                    DnnBin5 = detail.DnnBin5,
                    DnnBin6 = detail.DnnBin6,
                    DnnBin7 = detail.DnnBin7,
                    DnnBin8 = detail.DnnBin8,
                    DnnHazeAvg = detail.DnnHazeAvg,
                    DnnHazeMedian = detail.DnnHazeMedian,
                    DnnHazeStdDev = detail.DnnHazeStdDev,
                    DnnLpd = detail.DnnLpd,
                    DnnLpdES = detail.DnnLpdES,
                    DnnLpdN = detail.DnnLpdN,
                    DnnMicroScr = detail.DnnMicroScr,
                    DnnScr = detail.DnnScr,
                    DnnSlip = detail.DnnSlip,
                    DwnAll = detail.DwnAll,
                    DwnArea = detail.DwnArea,
                    DwnAreaCount = detail.DwnAreaCount,
                    DwnBin1 = detail.DwnBin1,
                    DwnBin2 = detail.DwnBin2,
                    DwnBin3 = detail.DwnBin3,
                    DwnBin4 = detail.DwnBin4,
                    DwnBin5 = detail.DwnBin5,
                    DwnBin6 = detail.DwnBin6,
                    DwnBin7 = detail.DwnBin7,
                    DwnBin8 = detail.DwnBin8,
                    DwnHazeAvg = detail.DwnHazeAvg,
                    DwnHazeMedian = detail.DwnHazeMedian,
                    DwnHazeStdDev = detail.DwnHazeStdDev,
                    DwnLpd = detail.DwnLpd,
                    DwnLpdES = detail.DwnLpdES,
                    DwnLpdN = detail.DwnLpdN,
                    DwnMicroScr = detail.DwnMicroScr,
                    DwnScr = detail.DwnScr,
                    DwnSlip = detail.DwnSlip
                };
                results.Add(description);
            }
        }
        return results;
    }

    private static Description GetDisplayNames()
    {
        Description result = new();
        return result;
    }

    private Description GetDefault(IFileRead fileRead, Logistics logistics)
    {
        Description result = new()
        {
            Test = -1,
            Count = 0,
            Index = -1,
            //
            EventName = fileRead.EventName,
            NullData = fileRead.NullData,
            JobID = fileRead.CellInstanceName,
            Sequence = logistics.Sequence.ToString(),
            MesEntity = fileRead.MesEntity,
            ReportFullPath = logistics.ReportFullPath,
            ProcessJobID = logistics.ProcessJobID,
            MID = logistics.MID,
            //
            Date = nameof(Date),
            Employee = nameof(Employee),
            Lot = nameof(Lot),
            PSN = nameof(PSN),
            Reactor = nameof(Reactor),
            Recipe = nameof(Recipe),
            //
            Grade = nameof(Grade),
            HeaderUniqueId = nameof(HeaderUniqueId),
            RDS = nameof(RDS),
            Session = nameof(Session),
            Side = nameof(Side),
            SrcDest = nameof(SrcDest),
            UniqueId = nameof(UniqueId),
            WaferID = nameof(WaferID),
            //
            DcnAllMax = nameof(DcnAllMax),
            DcnAllMean = nameof(DcnAllMean),
            DcnAllMin = nameof(DcnAllMin),
            DcnAllStdDev = nameof(DcnAllStdDev),
            DcnAreaCountMax = nameof(DcnAreaCountMax),
            DcnAreaCountMean = nameof(DcnAreaCountMean),
            DcnAreaCountMin = nameof(DcnAreaCountMin),
            DcnAreaCountStdDev = nameof(DcnAreaCountStdDev),
            DcnAreaMax = nameof(DcnAreaMax),
            DcnAreaMean = nameof(DcnAreaMean),
            DcnAreaMin = nameof(DcnAreaMin),
            DcnAreaStdDev = nameof(DcnAreaStdDev),
            DcnBin1Max = nameof(DcnBin1Max),
            DcnBin1Mean = nameof(DcnBin1Mean),
            DcnBin1Min = nameof(DcnBin1Min),
            DcnBin1StdDev = nameof(DcnBin1StdDev),
            DcnBin2Max = nameof(DcnBin2Max),
            DcnBin2Mean = nameof(DcnBin2Mean),
            DcnBin2Min = nameof(DcnBin2Min),
            DcnBin2StdDev = nameof(DcnBin2StdDev),
            DcnBin3Max = nameof(DcnBin3Max),
            DcnBin3Mean = nameof(DcnBin3Mean),
            DcnBin3Min = nameof(DcnBin3Min),
            DcnBin3StdDev = nameof(DcnBin3StdDev),
            DcnBin4Max = nameof(DcnBin4Max),
            DcnBin4Mean = nameof(DcnBin4Mean),
            DcnBin4Min = nameof(DcnBin4Min),
            DcnBin4StdDev = nameof(DcnBin4StdDev),
            DcnBin5Max = nameof(DcnBin5Max),
            DcnBin5Mean = nameof(DcnBin5Mean),
            DcnBin5Min = nameof(DcnBin5Min),
            DcnBin5StdDev = nameof(DcnBin5StdDev),
            DcnBin6Max = nameof(DcnBin6Max),
            DcnBin6Mean = nameof(DcnBin6Mean),
            DcnBin6Min = nameof(DcnBin6Min),
            DcnBin6StdDev = nameof(DcnBin6StdDev),
            DcnBin7Max = nameof(DcnBin7Max),
            DcnBin7Mean = nameof(DcnBin7Mean),
            DcnBin7Min = nameof(DcnBin7Min),
            DcnBin7StdDev = nameof(DcnBin7StdDev),
            DcnBin8Max = nameof(DcnBin8Max),
            DcnBin8Mean = nameof(DcnBin8Mean),
            DcnBin8Min = nameof(DcnBin8Min),
            DcnBin8StdDev = nameof(DcnBin8StdDev),
            DcnHazeAvgMax = nameof(DcnHazeAvgMax),
            DcnHazeAvgMean = nameof(DcnHazeAvgMean),
            DcnHazeAvgMin = nameof(DcnHazeAvgMin),
            DcnHazeAvgStdDev = nameof(DcnHazeAvgStdDev),
            DcnHazeMedianMax = nameof(DcnHazeMedianMax),
            DcnHazeMedianMean = nameof(DcnHazeMedianMean),
            DcnHazeMedianMin = nameof(DcnHazeMedianMin),
            DcnHazeMedianStdDev = nameof(DcnHazeMedianStdDev),
            DcnHazeStdDevMax = nameof(DcnHazeStdDevMax),
            DcnHazeStdDevMean = nameof(DcnHazeStdDevMean),
            DcnHazeStdDevMin = nameof(DcnHazeStdDevMin),
            DcnHazeStdDevStdDev = nameof(DcnHazeStdDevStdDev),
            DcnLpdESMax = nameof(DcnLpdESMax),
            DcnLpdESMean = nameof(DcnLpdESMean),
            DcnLpdESMin = nameof(DcnLpdESMin),
            DcnLpdESStdDev = nameof(DcnLpdESStdDev),
            DcnLpdMax = nameof(DcnLpdMax),
            DcnLpdMean = nameof(DcnLpdMean),
            DcnLpdMin = nameof(DcnLpdMin),
            DcnLpdNMax = nameof(DcnLpdNMax),
            DcnLpdNMean = nameof(DcnLpdNMean),
            DcnLpdNMin = nameof(DcnLpdNMin),
            DcnLpdNStdDev = nameof(DcnLpdNStdDev),
            DcnLpdStdDev = nameof(DcnLpdStdDev),
            DcnMicroScrMax = nameof(DcnMicroScrMax),
            DcnMicroScrMean = nameof(DcnMicroScrMean),
            DcnMicroScrMin = nameof(DcnMicroScrMin),
            DcnMicroScrStdDev = nameof(DcnMicroScrStdDev),
            DcnScrMax = nameof(DcnScrMax),
            DcnScrMean = nameof(DcnScrMean),
            DcnScrMin = nameof(DcnScrMin),
            DcnScrStdDev = nameof(DcnScrStdDev),
            DcnSlipMax = nameof(DcnSlipMax),
            DcnSlipMean = nameof(DcnSlipMean),
            DcnSlipMin = nameof(DcnSlipMin),
            DcnSlipStdDev = nameof(DcnSlipStdDev),
            DnnAllMax = nameof(DnnAllMax),
            DnnAllMean = nameof(DnnAllMean),
            DnnAllMin = nameof(DnnAllMin),
            DnnAllStdDev = nameof(DnnAllStdDev),
            DnnAreaCountMax = nameof(DnnAreaCountMax),
            DnnAreaCountMean = nameof(DnnAreaCountMean),
            DnnAreaCountMin = nameof(DnnAreaCountMin),
            DnnAreaCountStdDev = nameof(DnnAreaCountStdDev),
            DnnAreaMax = nameof(DnnAreaMax),
            DnnAreaMean = nameof(DnnAreaMean),
            DnnAreaMin = nameof(DnnAreaMin),
            DnnAreaStdDev = nameof(DnnAreaStdDev),
            DnnBin1Max = nameof(DnnBin1Max),
            DnnBin1Mean = nameof(DnnBin1Mean),
            DnnBin1Min = nameof(DnnBin1Min),
            DnnBin1StdDev = nameof(DnnBin1StdDev),
            DnnBin2Max = nameof(DnnBin2Max),
            DnnBin2Mean = nameof(DnnBin2Mean),
            DnnBin2Min = nameof(DnnBin2Min),
            DnnBin2StdDev = nameof(DnnBin2StdDev),
            DnnBin3Max = nameof(DnnBin3Max),
            DnnBin3Mean = nameof(DnnBin3Mean),
            DnnBin3Min = nameof(DnnBin3Min),
            DnnBin3StdDev = nameof(DnnBin3StdDev),
            DnnBin4Max = nameof(DnnBin4Max),
            DnnBin4Mean = nameof(DnnBin4Mean),
            DnnBin4Min = nameof(DnnBin4Min),
            DnnBin4StdDev = nameof(DnnBin4StdDev),
            DnnBin5Max = nameof(DnnBin5Max),
            DnnBin5Mean = nameof(DnnBin5Mean),
            DnnBin5Min = nameof(DnnBin5Min),
            DnnBin5StdDev = nameof(DnnBin5StdDev),
            DnnBin6Max = nameof(DnnBin6Max),
            DnnBin6Mean = nameof(DnnBin6Mean),
            DnnBin6Min = nameof(DnnBin6Min),
            DnnBin6StdDev = nameof(DnnBin6StdDev),
            DnnBin7Max = nameof(DnnBin7Max),
            DnnBin7Mean = nameof(DnnBin7Mean),
            DnnBin7Min = nameof(DnnBin7Min),
            DnnBin7StdDev = nameof(DnnBin7StdDev),
            DnnBin8Max = nameof(DnnBin8Max),
            DnnBin8Mean = nameof(DnnBin8Mean),
            DnnBin8Min = nameof(DnnBin8Min),
            DnnBin8StdDev = nameof(DnnBin8StdDev),
            DnnHazeAvgMax = nameof(DnnHazeAvgMax),
            DnnHazeAvgMean = nameof(DnnHazeAvgMean),
            DnnHazeAvgMin = nameof(DnnHazeAvgMin),
            DnnHazeAvgStdDev = nameof(DnnHazeAvgStdDev),
            DnnHazeMedianMax = nameof(DnnHazeMedianMax),
            DnnHazeMedianMean = nameof(DnnHazeMedianMean),
            DnnHazeMedianMin = nameof(DnnHazeMedianMin),
            DnnHazeMedianStdDev = nameof(DnnHazeMedianStdDev),
            DnnHazeStdDevMax = nameof(DnnHazeStdDevMax),
            DnnHazeStdDevMean = nameof(DnnHazeStdDevMean),
            DnnHazeStdDevMin = nameof(DnnHazeStdDevMin),
            DnnHazeStdDevStdDev = nameof(DnnHazeStdDevStdDev),
            DnnLpdESMax = nameof(DnnLpdESMax),
            DnnLpdESMean = nameof(DnnLpdESMean),
            DnnLpdESMin = nameof(DnnLpdESMin),
            DnnLpdESStdDev = nameof(DnnLpdESStdDev),
            DnnLpdMax = nameof(DnnLpdMax),
            DnnLpdMean = nameof(DnnLpdMean),
            DnnLpdMin = nameof(DnnLpdMin),
            DnnLpdNMax = nameof(DnnLpdNMax),
            DnnLpdNMean = nameof(DnnLpdNMean),
            DnnLpdNMin = nameof(DnnLpdNMin),
            DnnLpdNStdDev = nameof(DnnLpdNStdDev),
            DnnLpdStdDev = nameof(DnnLpdStdDev),
            DnnMicroScrMax = nameof(DnnMicroScrMax),
            DnnMicroScrMean = nameof(DnnMicroScrMean),
            DnnMicroScrMin = nameof(DnnMicroScrMin),
            DnnMicroScrStdDev = nameof(DnnMicroScrStdDev),
            DnnScrMax = nameof(DnnScrMax),
            DnnScrMean = nameof(DnnScrMean),
            DnnScrMin = nameof(DnnScrMin),
            DnnScrStdDev = nameof(DnnScrStdDev),
            DnnSlipMax = nameof(DnnSlipMax),
            DnnSlipMean = nameof(DnnSlipMean),
            DnnSlipMin = nameof(DnnSlipMin),
            DnnSlipStdDev = nameof(DnnSlipStdDev),
            DwnAllMax = nameof(DwnAllMax),
            DwnAllMean = nameof(DwnAllMean),
            DwnAllMin = nameof(DwnAllMin),
            DwnAllStdDev = nameof(DwnAllStdDev),
            DwnAreaCountMax = nameof(DwnAreaCountMax),
            DwnAreaCountMean = nameof(DwnAreaCountMean),
            DwnAreaCountMin = nameof(DwnAreaCountMin),
            DwnAreaCountStdDev = nameof(DwnAreaCountStdDev),
            DwnAreaMax = nameof(DwnAreaMax),
            DwnAreaMean = nameof(DwnAreaMean),
            DwnAreaMin = nameof(DwnAreaMin),
            DwnAreaStdDev = nameof(DwnAreaStdDev),
            DwnBin1Max = nameof(DwnBin1Max),
            DwnBin1Mean = nameof(DwnBin1Mean),
            DwnBin1Min = nameof(DwnBin1Min),
            DwnBin1StdDev = nameof(DwnBin1StdDev),
            DwnBin2Max = nameof(DwnBin2Max),
            DwnBin2Mean = nameof(DwnBin2Mean),
            DwnBin2Min = nameof(DwnBin2Min),
            DwnBin2StdDev = nameof(DwnBin2StdDev),
            DwnBin3Max = nameof(DwnBin3Max),
            DwnBin3Mean = nameof(DwnBin3Mean),
            DwnBin3Min = nameof(DwnBin3Min),
            DwnBin3StdDev = nameof(DwnBin3StdDev),
            DwnBin4Max = nameof(DwnBin4Max),
            DwnBin4Mean = nameof(DwnBin4Mean),
            DwnBin4Min = nameof(DwnBin4Min),
            DwnBin4StdDev = nameof(DwnBin4StdDev),
            DwnBin5Max = nameof(DwnBin5Max),
            DwnBin5Mean = nameof(DwnBin5Mean),
            DwnBin5Min = nameof(DwnBin5Min),
            DwnBin5StdDev = nameof(DwnBin5StdDev),
            DwnBin6Max = nameof(DwnBin6Max),
            DwnBin6Mean = nameof(DwnBin6Mean),
            DwnBin6Min = nameof(DwnBin6Min),
            DwnBin6StdDev = nameof(DwnBin6StdDev),
            DwnBin7Max = nameof(DwnBin7Max),
            DwnBin7Mean = nameof(DwnBin7Mean),
            DwnBin7Min = nameof(DwnBin7Min),
            DwnBin7StdDev = nameof(DwnBin7StdDev),
            DwnBin8Max = nameof(DwnBin8Max),
            DwnBin8Mean = nameof(DwnBin8Mean),
            DwnBin8Min = nameof(DwnBin8Min),
            DwnBin8StdDev = nameof(DwnBin8StdDev),
            DwnHazeAvgMax = nameof(DwnHazeAvgMax),
            DwnHazeAvgMean = nameof(DwnHazeAvgMean),
            DwnHazeAvgMin = nameof(DwnHazeAvgMin),
            DwnHazeAvgStdDev = nameof(DwnHazeAvgStdDev),
            DwnHazeMedianMax = nameof(DwnHazeMedianMax),
            DwnHazeMedianMean = nameof(DwnHazeMedianMean),
            DwnHazeMedianMin = nameof(DwnHazeMedianMin),
            DwnHazeMedianStdDev = nameof(DwnHazeMedianStdDev),
            DwnHazeStdDevMax = nameof(DwnHazeStdDevMax),
            DwnHazeStdDevMean = nameof(DwnHazeStdDevMean),
            DwnHazeStdDevMin = nameof(DwnHazeStdDevMin),
            DwnHazeStdDevStdDev = nameof(DwnHazeStdDevStdDev),
            DwnLpdESMax = nameof(DwnLpdESMax),
            DwnLpdESMean = nameof(DwnLpdESMean),
            DwnLpdESMin = nameof(DwnLpdESMin),
            DwnLpdESStdDev = nameof(DwnLpdESStdDev),
            DwnLpdMax = nameof(DwnLpdMax),
            DwnLpdMean = nameof(DwnLpdMean),
            DwnLpdMin = nameof(DwnLpdMin),
            DwnLpdNMax = nameof(DwnLpdNMax),
            DwnLpdNMean = nameof(DwnLpdNMean),
            DwnLpdNMin = nameof(DwnLpdNMin),
            DwnLpdNStdDev = nameof(DwnLpdNStdDev),
            DwnLpdStdDev = nameof(DwnLpdStdDev),
            DwnMicroScrMax = nameof(DwnMicroScrMax),
            DwnMicroScrMean = nameof(DwnMicroScrMean),
            DwnMicroScrMin = nameof(DwnMicroScrMin),
            DwnMicroScrStdDev = nameof(DwnMicroScrStdDev),
            DwnScrMax = nameof(DwnScrMax),
            DwnScrMean = nameof(DwnScrMean),
            DwnScrMin = nameof(DwnScrMin),
            DwnScrStdDev = nameof(DwnScrStdDev),
            DwnSlipMax = nameof(DwnSlipMax),
            DwnSlipMean = nameof(DwnSlipMean),
            DwnSlipMin = nameof(DwnSlipMin),
            DwnSlipStdDev = nameof(DwnSlipStdDev),
            DcnAll = nameof(DcnAll),
            DcnArea = nameof(DcnArea),
            DcnAreaCount = nameof(DcnAreaCount),
            DcnBin1 = nameof(DcnBin1),
            DcnBin2 = nameof(DcnBin2),
            DcnBin3 = nameof(DcnBin3),
            DcnBin4 = nameof(DcnBin4),
            DcnBin5 = nameof(DcnBin5),
            DcnBin6 = nameof(DcnBin6),
            DcnBin7 = nameof(DcnBin7),
            DcnBin8 = nameof(DcnBin8),
            DcnHazeAvg = nameof(DcnHazeAvg),
            DcnHazeMedian = nameof(DcnHazeMedian),
            DcnHazeStdDev = nameof(DcnHazeStdDev),
            DcnLpd = nameof(DcnLpd),
            DcnLpdES = nameof(DcnLpdES),
            DcnLpdN = nameof(DcnLpdN),
            DcnMicroScr = nameof(DcnMicroScr),
            DcnScr = nameof(DcnScr),
            DcnSlip = nameof(DcnSlip),
            DnnAll = nameof(DnnAll),
            DnnArea = nameof(DnnArea),
            DnnAreaCount = nameof(DnnAreaCount),
            DnnBin1 = nameof(DnnBin1),
            DnnBin2 = nameof(DnnBin2),
            DnnBin3 = nameof(DnnBin3),
            DnnBin4 = nameof(DnnBin4),
            DnnBin5 = nameof(DnnBin5),
            DnnBin6 = nameof(DnnBin6),
            DnnBin7 = nameof(DnnBin7),
            DnnBin8 = nameof(DnnBin8),
            DnnHazeAvg = nameof(DnnHazeAvg),
            DnnHazeMedian = nameof(DnnHazeMedian),
            DnnHazeStdDev = nameof(DnnHazeStdDev),
            DnnLpd = nameof(DnnLpd),
            DnnLpdES = nameof(DnnLpdES),
            DnnLpdN = nameof(DnnLpdN),
            DnnMicroScr = nameof(DnnMicroScr),
            DnnScr = nameof(DnnScr),
            DnnSlip = nameof(DnnSlip),
            DwnAll = nameof(DwnAll),
            DwnArea = nameof(DwnArea),
            DwnAreaCount = nameof(DwnAreaCount),
            DwnBin1 = nameof(DwnBin1),
            DwnBin2 = nameof(DwnBin2),
            DwnBin3 = nameof(DwnBin3),
            DwnBin4 = nameof(DwnBin4),
            DwnBin5 = nameof(DwnBin5),
            DwnBin6 = nameof(DwnBin6),
            DwnBin7 = nameof(DwnBin7),
            DwnBin8 = nameof(DwnBin8),
            DwnHazeAvg = nameof(DwnHazeAvg),
            DwnHazeMedian = nameof(DwnHazeMedian),
            DwnHazeStdDev = nameof(DwnHazeStdDev),
            DwnLpd = nameof(DwnLpd),
            DwnLpdES = nameof(DwnLpdES),
            DwnLpdN = nameof(DwnLpdN),
            DwnMicroScr = nameof(DwnMicroScr),
            DwnScr = nameof(DwnScr),
            DwnSlip = nameof(DwnSlip),
        };
        return result;
    }

    internal static string GetDateFormat() => "MM/dd/yyyy hh:mm:ss tt";

}