namespace Adaptation.FileHandlers.MoveAllFiles.ApiController;

public readonly struct Notification
{
    public KeyPressEvent KeyPressEvent { get; }
    public string LastScanServiceResultValue { get; }

    [System.Text.Json.Serialization.JsonConstructor]
    public Notification(KeyPressEvent keyPressEvent, string lastScanServiceResultValue)
    {
        KeyPressEvent = keyPressEvent;
        LastScanServiceResultValue = lastScanServiceResultValue;
    }

}